#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "carte.h"


/*!
* \file carte.c
* \brief Fichier contenant le code des fonctions liees aux cartes.
*/


char* ExtraireCarte(int numero)
{
    return LireCarte("../resources/Maps.txt",numero);
}


/*!
 * \fn Carte* LireCarte(int num)
 * \brief La fonction recupere la n-ieme carte dans un fichier et renvoie un pointeur sur la carte cree
 *
 * \return Un pointeur sur une tableau de lettres.
 */
char* LireCarte(const char *filename, int num)
{
    char char_actuel;
    int num_map = 0, nb_lignes = 0, nb_colonnes = 0, i=0, j=0, k=0, taille_Tableau = 0;
    FILE* file_map = NULL;
    file_map = fopen(filename, "r");

    fseek(file_map, 3, SEEK_SET);
    fscanf(file_map,"%d %d %d", &num_map, &nb_lignes, &nb_colonnes); /*! Lecture du nom et de la taille de la premiere map */

    fgetc(file_map);
    fgetc(file_map);

    while(num_map < num)    /*! Descend jusqu' la prochaine map */
    {
        for(k=0; k<nb_colonnes; k++) /*! Descend jusqu' la prochaine map */
        {
            fseek(file_map,nb_lignes+2,SEEK_CUR);
        }
        fgetc(file_map);
        fgetc(file_map);
        fseek(file_map, 3, SEEK_CUR);

        fscanf(file_map,"%d %d %d", &num_map, &nb_lignes, &nb_colonnes);  /*! Lecture du nom et de la taille de la map */
        fgetc(file_map);
        fgetc(file_map);
    }

    char * TableauCarte = NULL;
    taille_Tableau = nb_colonnes*nb_lignes*sizeof(char);
    TableauCarte = malloc(taille_Tableau);

    for(i=0; i<nb_colonnes; i++)
    {
        for(j=0; j<nb_lignes; j++)
        {
            char_actuel = fgetc(file_map);
            TableauCarte[nb_lignes*i+j] = char_actuel;
        }
        fgetc(file_map);
    }

/* Test Tableau

    for(j=0; j<nb_lignes*nb_colonnes; j++)
    {
        printf("La valeur %d du tableau vaut : %c\n",j,TableauCarte[j]);
    }

    fclose(file_map);
*/
    return TableauCarte;
}



